// www.sgm.siedlce.pl

// dekodowanie sygnalu C-PPM (PPM-Sum)
// wynki odczytu w zmiennej wektorowej Chan[]
// Chan[0] impuls synchronizujacy
// Chan[1] kanal 1
// ...
// Chan[8] kanal 8

/*  pomiar czasu (micros) za pomocą biblioteki
===================================================================================================
<eRCaGuy_Timer2_Counter.h> by Gabriel Staples
Visit my blog at http://electricrcaircraftguy.blogspot.com/
-My contact info is available by clicking the "Contact Me" tab at the top of my blog.
-Please support my work & contributions by buying something here: https://sites.google.com/site/ercaguystore1/
My original post containing this code can be found here: http://electricrcaircraftguy.blogspot.com/2014/02/Timer2Counter-more-precise-Arduino-micros-function.html
Written: 17 May 2014
Updated: 30 May 2014
===================================================================================================
  LICENSE & DISCLAIMER
  Copyright (C) 2015 Gabriel Staples.  All right reserved.
  
  ------------------------------------------------------------------------------------------------
  License: GNU Lesser General Public License Version 3 (LGPLv3) or later - https://www.gnu.org/licenses/lgpl.html
  ------------------------------------------------------------------------------------------------

  This file is part of eRCaGuy_Timer2_Counter.
  
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program.  If not, see http://www.gnu.org/licenses/
===================================================================================================
*/


#include <eRCaGuy_Timer2_Counter.h>
// funkcja timer2.get_count()  podaje wynik w jednostkach 0.5us
// funkcja timer2.get_micros() podaje wynik w mikrosekundach
 
const int butIrq = 1;     // Irq 1 na Pin3 (wejscie)
 
volatile int pulse_t1 = 0;  
volatile int pulse_t2 = 0;  
volatile int pulse_t3 = 0;  

int t1_t2_micros = 0;                                  
int t1_t3_micros = 0;
long m_timer=0;         
long gaptimer2 = 500;  //co jaki czas wyswietlac dane

float valPulse;           // zmienna na dlugosc 'Pulse' (microsec)
float valPeriod;          // zmienna na dlugosc 'Period'

// poczatkowe wartosci ('neutrum')
int Chan[] = {5000,1100,1500,1500,1500,1500,1500,1500,1500};
byte ChNum;

//************************************************************program 
void setup() {
 //obowiazkowa inicjalizacja Timer2 wymagana przez
 //biblioteke <eRCaGuy_Timer2_Counter.h>
 timer2.setup();
 
 Serial.begin(115200);  //w czasie uruchamiania
 
 attachInterrupt(0, pulse_rising, RISING);
 
}
 
void loop() {
 // obsluga wyswietlania zmierzonych wartosci co gaptimer2 
 if (millis()- m_timer > gaptimer2) {
   m_timer=millis();
     
   Serial.print("0:"); Serial.print(Chan[0]); Serial.print("; ");
   Serial.print("1:"); Serial.print(Chan[1]); Serial.print("; ");
   Serial.print("2:"); Serial.print(Chan[2]); Serial.print("; ");
   Serial.print("3:"); Serial.print(Chan[3]); Serial.print("; ");
   Serial.print("4:"); Serial.print(Chan[4]); Serial.print("; ");
   Serial.print("5:"); Serial.print(Chan[5]); Serial.print("; ");
   Serial.print("6:"); Serial.print(Chan[6]); Serial.print("; ");
   Serial.print("7:"); Serial.print(Chan[7]); Serial.print("; ");
   Serial.print("8:"); Serial.print(Chan[8]); Serial.println();
   
 }
 
}



// obsluga przerwania 0 (rising) //poczatek impulsu
void pulse_rising() {
  attachInterrupt(0, pulse_falling, FALLING);
  pulse_t3 = pulse_t1;
  pulse_t1 = timer2.get_micros();
  t1_t3_micros = pulse_t1 - pulse_t3; //period
   
  if (ChNum < 9) {
    Chan[ChNum] = t1_t3_micros;
    ChNum ++;
  }   
  
}

// obsluga przerwania 0 (falling)  //koniec impulsu
void pulse_falling() {
  attachInterrupt(0, pulse_rising, RISING);
  pulse_t2 = timer2.get_micros();
  t1_t2_micros = pulse_t2 - pulse_t1;
  
  if (t1_t2_micros>3000) {
  // FrameOK = 1;
   ChNum = 0; 
  }  
  
}
